#!@@SH@@
#
# opkhelper
# src/oh-installfiles
# Install files into a binary package staging area.
#
# Copyright (C) 2012 Patrick "P. J." McDermott
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

. '@@LIBOPKBUILD_1@@/load.sm'

ob_use locale
ob_use output
ob_use package

files_ifs='
'

main()
{
	ob_set_locale_path '@@LOCALEDIR@@/%s/LC_MESSAGES/%s.ms'
	ob_set_text_domain 'opkhelper'

	ob_init_package '..'
	ob_parse_package_metadata -c '.opkbuild.cache'

	for pkg in ${OPK_PACKAGES}; do
		[ -r "../${pkg}.pkg/files" ] || continue

		ob_info "$(ob_get_msg 'installing_files')" "${pkg}"

		mkdir -p "${pkg}.data"
		chmod 755 "${pkg}.data"

		while IFS="${files_ifs}" read -r pattern; do
			for file in dest/${pattern}; do
				[ -e "${file}" ] || continue
				file="${file#dest}"
				mkdir -p "${pkg}.data/${file%/*}"
				# TODO: If file, ln file.  If dir, recursively mkdir and ln.
				mv "${PWD}/dest/${file}" "${pkg}.data/${file}"
			done
		done <"../${pkg}.pkg/files"
	done
}

main "${@}"
